﻿//
// Major game code goes here
//
package 
{
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	import flash.utils.*;  // - EXTRA CREDIT !!

	public class GameFunctions_v05 extends MovieClip
	{
		// game constants
		private static  const totalMS:int = 7000; // - EXTRA CREDIT !!
		// game variables
		private var customFormat:TextFormat = new TextFormat();
		private var gameScore:uint;
		private var gameScoreField:TextField;
		//
		private var gameStartTime:int;
		private var gameTime:int;
		private var gameTimeField:TextField;
		//
		public function GameFunctions_v05():void
		{
			// Custom text format var
			customFormat.font = "Verdana";
			customFormat.color = 0x333333;
			customFormat.size = 24;
			// Show inital score of hundred
			gameScoreField = new TextField();
			gameScoreField.x = 10;
			gameScoreField.y = 10;
			gameScoreField.width = 200;
			gameScoreField.height = 100;
			gameScoreField.selectable = false;
			gameScoreField.setTextFormat(customFormat);
			addChild(gameScoreField);
			//
			gameScore = 100;
			showGameScore();
			// Display and Start timer
			gameTimeField = new TextField();
			gameTimeField.x = 470;
			gameTimeField.y = 10;
			gameTimeField.width = 200;
			gameTimeField.height = 100;
			gameTimeField.selectable = false;
			gameTimeField.setTextFormat(customFormat);
			addChild(gameTimeField);
			//
			gameStartTime = getTimer();
			addEventListener(Event.ENTER_FRAME,showTime);
			// Show space ship in a sprite
			StartShipMover();
		}
		public function showGameScore()
		{
			gameScoreField.text = "Score= "+String(gameScore);
			gameScoreField.setTextFormat(customFormat);
			// Sync root var with private var
			MovieClip(root).MainScreenGameScore = gameScore;
		}

		public function showTime(event:Event)
		{
			// Count Down timer - EXTRA CREDIT !!
			gameTime = (totalMS+1000) - (getTimer()-gameStartTime);
			trace("gameTime = " + gameTime);
			// Count Down timer - EXTRA CREDIT !!
			if (gameTime >= 0) {
				gameTimeField.text = "Time= "+clockTime(gameTime);
				gameTimeField.setTextFormat(customFormat);
			} else {
				//
				MovieClip(root).TechBeepObj.play();
				// Sync root var with private var
				MovieClip(root).MainScreenGameScore = gameScore;
				// Stop this forever loop
				removeEventListener(Event.ENTER_FRAME,showTime);
				//
				BlowUpShip();
			}
		}
		public function clockTime(ms:int)
		{
			var seconds:int = Math.floor(ms/1000);
			var minutes:int = Math.floor(seconds/60);
			var timeString:String;
			seconds -= minutes*60;
			if (minutes >= 10 ) {
				timeString = minutes+":"+String(seconds+100).substr(1,2);
			} else {
				timeString = "0"+minutes+":"+String(seconds+100).substr(1,2);
			}
			return timeString;
		}
		//
		// Game Objects
		private var gameScreen_Obj:Sprite;
		private var ship_Obj:Ship;
		private var delayTimer:Timer;
		//
		//
		public function StartShipMover():void
		{
			trace("Start Ship Mover!");
			//
			// set up game sprites
			gameScreen_Obj = new Sprite();
			addChild(gameScreen_Obj);
			//
			// create, position, and add new ship to screen
			ship_Obj = new Ship();
			ship_Obj.gotoAndStop(1);
			ship_Obj.x = 320;
			ship_Obj.y = 240;
			ship_Obj.rotation = -90;
			ship_Obj.shield.visible = false;
			gameScreen_Obj.addChild(ship_Obj);
			// set up listeners 
			stage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownFunction);
			/* NOTE: 
				User will have to click stage in order to activate keys.
				Offer 2 extra points to final grade to any student that can
				fix this bug in their homework assignment. Will show solution
				next week.
			*/
			// EXTRA CREDIT SOLUTION
			stage.focus = MovieClip(root);
		}
		// register key presses
		public function keyDownFunction(event:KeyboardEvent)
		{
			if (event.keyCode == 37) {// LEFT arrow
				ship_Obj.x -= 10;
			} else if (event.keyCode == 38) {// UP arrow
				ship_Obj.y -= 10;
			} else if (event.keyCode == 39) {// RIGHT arrow
				ship_Obj.x += 10;
			} else if (event.keyCode == 40) {// DOWN arraow
				ship_Obj.y += 10;
			}
		}
		public function BlowUpShip():void
		{
			ship_Obj.gotoAndPlay("explode");
			// Give explode animation 1 second to complete before doing anything else
			delayTimer = new Timer(1000,1);// 1 second delay
			delayTimer.addEventListener(TimerEvent.TIMER_COMPLETE,RemoveShipFromStage);
			delayTimer.start();
		}
		public function RemoveShipFromStage(event:TimerEvent):void
		{
			trace("Remove Ship from sprite");
			gameScreen_Obj.removeChild(ship_Obj);
			//
			// Jump to winnner or loser screen
			if (Math.floor(Math.random()*2)) {
				MovieClip(root).gotoAndPlay("Loser");
			} else {
				MovieClip(root).gotoAndPlay("Winner");
			}
			//
			// Put buttons back on stage
			MovieClip(root).DisplayAllButtons();
		}
	}
}